import { isString } from 'lodash'
import {
    REQUEST_START,
    REQUEST_KO, 
    SHOW_SPINNER,
    HIDE_SPINNER,
    SHOW_NOTIFICATION, 
    HIDE_NOTIFICATION, 
    REQUEST_OK
} from '../constants/ActionTypes';

const initialState = {
    spinner: {
        isOpen: false,
        message: null,
    },
    notification: {
        isOpen: false,
        message: null
    }
}

/**
 * 
 * @param {*} state 
 * @param {*} action 
 */
export const app = (state = initialState, action) => {
    if (action.type === SHOW_SPINNER || action.type === REQUEST_START) {
        state = {
            ...state,
            spinner: {
                isOpen: true,
                message: action.payload
            }
        }
    }

    if (action.type === HIDE_SPINNER || action.type === REQUEST_OK) {
        state = {
            ...state,
            spinner: {
                isOpen: false,
                message: isString(action.payload) ? action.payload : null
            }
        }
    }

    if (action.type === SHOW_NOTIFICATION || action.type === REQUEST_KO) {
        state = {
            ...state,
            notification: {
                isOpen: true,
                message: isString(action.payload) ? action.payload : null
            }
        }
    }

    if (action.type === HIDE_NOTIFICATION) {
        state = {
            ...state,
            notification: {
                isOpen: false,
                message: null
            }
        }
    }

    return state
}